package com.company.collectionchange.web.screens;

import com.company.collectionchange.entity.ExtUser;
import com.haulmont.cuba.gui.app.security.user.edit.UserEditor;
import com.haulmont.cuba.gui.components.Button;
import com.haulmont.cuba.gui.screen.Subscribe;
import com.haulmont.cuba.security.entity.UserRole;

import javax.inject.Inject;
import javax.persistence.Entity;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Entity(name = "collectionchange_ExtUser")
public class ExtUserEditor extends UserEditor {
    @Inject
    private Button approveRequestedRoleBtn;

    @Subscribe
    public void onBeforeShow(BeforeShowEvent event) {
        setApproveRequestedRoleBtnVisibility();
        rolesDs.addCollectionChangeListener(e -> {
            setApproveRequestedRoleBtnVisibility();
        });
    }

    private void setApproveRequestedRoleBtnVisibility() {
        ExtUser user = (ExtUser) getEditedEntity();
        List<UserRole> userRoles = user.getUserRoles();

        // All of these checks seem to be necessary, as it appears a UserRole is first added without the
        // roleName property, then is updated again
        approveRequestedRoleBtn.setVisible(user.getRequestedRole() != null &&
                Objects.requireNonNull(userRoles).size() == 1 &&
                userRoles.get(0) != null &&
                userRoles.get(0).getRoleName() != null &&
                userRoles.get(0).getRoleName().equals("Registered"));
    }

    @Subscribe("approveRequestedRoleBtn")
    public void onApproveRequestedRoleBtnClick(Button.ClickEvent event) {
        //Remove all existing from collection
        List<UserRole> currentUserRoles = new ArrayList<>();
        currentUserRoles.addAll(getEditedEntity().getUserRoles());
        getEditedEntity().getUserRoles().removeAll(currentUserRoles);
        for (UserRole currentUserRole : currentUserRoles) {
            rolesDs.removeItem(currentUserRole);
        }
        //Add requested role to collection
        UserRole requestedUserRole = metadata.create(UserRole.class);
        requestedUserRole.setUser(getEditedEntity());
        requestedUserRole.setRoleName(((ExtUser) getEditedEntity()).getRequestedRole().getId());

        // ??????????
        rolesDs.addItem(requestedUserRole);
        getEditedEntity().getUserRoles().add(requestedUserRole);
        // UserRole is added to the table at this point, but the line is blank
        rolesDs.refresh();
        dsContext.refresh();
    }
}